diff --git a/src/main/java/net/minecraft/client/Minecraft.java b/src/main/java/net/minecraft/client/Minecraft.java
index e486c2786..d5b359d1c 100644
--- a/src/main/java/net/minecraft/client/Minecraft.java
+++ b/src/main/java/net/minecraft/client/Minecraft.java
@@ -1946,16 +2037,30 @@ public class Minecraft
         {
             I18n i18n = I18n.getInstance();
             LevelStorage saveHandler = saveFormat.getSaveHandler(worldDirName, false);
+            if (worldTypeGroup != null) {
+                for (Dimension dimension : Dimension.getDimensionList().values()) {
+                    WorldType worldType = worldTypeGroup.get(dimension);
+                    if (worldType != null) {
+                        DimensionData data = saveHandler.getDimensionData(dimension.id);
+                        if (data == null) {
+                            data = new DimensionData(worldType);
+                        } else {
+                            data.setWorldType(worldType);
+                        }
+                        saveHandler.saveDimensionData(dimension.id, data);
+                    }
+                }
+            }
             World world = new World(saveHandler, worldName, seed, null, null);
             if(world.isNewWorld)
             {
-                statsCounter.addValueToStat(StatList.createWorldStat, 1);
-                statsCounter.addValueToStat(StatList.startGameStat, 1);
+                statsCounter.add(StatList.createWorldStat, 1);
+                statsCounter.add(StatList.startGameStat, 1);
                 changeWorld(world, i18n.translateKey("gui.loading.label.generating"));
             } else
             {
-                statsCounter.addValueToStat(StatList.loadWorldStat, 1);
-                statsCounter.addValueToStat(StatList.startGameStat, 1);
+                statsCounter.add(StatList.loadWorldStat, 1);
+                statsCounter.add(StatList.startGameStat, 1);
                 changeWorld(world, i18n.translateKey("gui.loading.label.loading"));
             }
         }
@@ -2011,14 +2116,14 @@ public class Minecraft
         changeWorld(world, loadingTitle, null);
     }
 
-    public void changeWorld(World world, String loadingTitle, EntityPlayer player)
+    public void changeWorld(World world, String loadingTitle, Player player)
     {
     	mainMenuBackground.deleteTextures();
     	gameSettings.showCollisionBoxes.value = false;
     	
         fullbright = false;
-        statsCounter.func_27175_b();
-        statsCounter.syncStats();
+        statsCounter.fetchStats();
+        statsCounter.saveStats();
 
         if (world != null)
         {
@@ -2037,12 +2142,12 @@ public class Minecraft
         theWorld = world;
         if(world != null)
         {
-            playerController.initLevel(world);
+            playerController.initWorld(world);
             if(!isMultiplayerWorld())
             {
                 if(player == null)
                 {
-                    thePlayer = (EntityPlayerSP)world.func_4085_a(EntityPlayerSP.class);
+                    thePlayer = (LocalPlayer)world.findSubclassOf(LocalPlayer.class);
                 }
             }
             else if(thePlayer != null)
@@ -2055,11 +2160,11 @@ public class Minecraft
             }
             if(!world.isClientSide)
             {
-                func_6255_d(loadingTitle);
+                prepareLevel(loadingTitle);
             }
             if(thePlayer == null)
             {
-                thePlayer = (EntityPlayerSP)playerController.createPlayer(world);
+                thePlayer = (LocalPlayer)playerController.createPlayer(world);
                 thePlayer.resetPos();
                 playerController.initPlayer(thePlayer);
             }
@@ -2149,7 +2254,7 @@ public class Minecraft
         }
     }
 
-    private void func_6255_d(String loadingTitle)
+    private void prepareLevel(String loadingTitle)
     {
         loadingScreen.updateLoadingBackground(theWorld.dimension);
         loadingScreen.progressStartNoAbort(loadingTitle);
@@ -2236,7 +2341,7 @@ public class Minecraft
 
     public void respawn(boolean flag, int i)
     {
-    	EntityPlayer previousPlayer = thePlayer;
+    	Player previousPlayer = thePlayer;
         if(!theWorld.isClientSide && !theWorld.dimension.defaultWorldType.mayRespawn())
         {
             usePortal(i);
@@ -2252,7 +2357,7 @@ public class Minecraft
             lastDeathCoordinates = thePlayer.getLastDeathCoordinate();
             if(spawnCoordinates != null)
             {
-                bedSpawnCoordinates = EntityPlayer.getValidBedSpawnCoordinates(theWorld, spawnCoordinates);
+                bedSpawnCoordinates = Player.getValidBedSpawnCoordinates(theWorld, spawnCoordinates);
                 if(bedSpawnCoordinates == null)
                 {
                     thePlayer.sendTranslatedChatMessage("bed.notValid");
@@ -2280,7 +2385,7 @@ public class Minecraft
             theWorld.setEntityDead(thePlayer);
             playerGamemode = thePlayer.getGamemode();
         }
-        thePlayer = (EntityPlayerSP)playerController.createPlayer(theWorld);
+        thePlayer = (LocalPlayer)playerController.createPlayer(theWorld);
         thePlayer.dimension = i;
         thePlayer.setGamemode(playerGamemode);
         thePlayer.messageHistory = previousPlayer.messageHistory;
@@ -2305,18 +2410,18 @@ public class Minecraft
         thePlayer.id = j;
         thePlayer.func_6420_o();
         playerController.adjustPlayer(thePlayer);
-        func_6255_d("Respawning");
+        prepareLevel("Respawning");
         if(currentScreen instanceof GuiGameOver)
         {
             displayGuiScreen(null);
         }
     }
 
-    public NetClientHandler getSendQueue()
+    public ClientPacketHandler getSendQueue()
     {
-        if(thePlayer instanceof EntityClientPlayerMP)
+        if(thePlayer instanceof MultiplayerLocalPlayer)
         {
-            return ((EntityClientPlayerMP)thePlayer).sendQueue;
+            return ((MultiplayerLocalPlayer)thePlayer).sendQueue;
         } else
         {
             return null;
diff --git a/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java b/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
index 16e748cea..89fc87b6b 100644
--- a/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
+++ b/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
@@ -11,12 +11,13 @@ import de.jcm.discordgamesdk.CreateParams;
 import de.jcm.discordgamesdk.GameSDKException;
 import de.jcm.discordgamesdk.activity.Activity;
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.entity.player.EntityClientPlayerMP;
+import net.minecraft.client.entity.player.MultiplayerLocalPlayer;
 import net.minecraft.client.gui.GuiIngameMenu;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.weather.Weather;
+import net.minecraft.core.world.weather.Weathers;
 
 public class RichPresenceHandlerThread extends Thread
 {
@@ -63,13 +64,13 @@ public class RichPresenceHandlerThread extends Thread
     static
     {
         // overworldClear
-        weatherNamesMap.put(Weather.overworldRain, "in the rain");
-        weatherNamesMap.put(Weather.overworldSnow, "in the snow");
-        weatherNamesMap.put(Weather.overworldStorm, "in a storm");
-        weatherNamesMap.put(Weather.overworldFog, "in thick fog");
+        weatherNamesMap.put(Weathers.OVERWORLD_RAIN, "in the rain");
+        weatherNamesMap.put(Weathers.OVERWORLD_SNOW, "in the snow");
+        weatherNamesMap.put(Weathers.OVERWORLD_STORM, "in a storm");
+        weatherNamesMap.put(Weathers.OVERWORLD_FOG, "in thick fog");
         // overworldHellClear
         // overworldWoodsClear
-        weatherNamesMap.put(Weather.overworldWinterSnow, "in an endless snowstorm");
+        weatherNamesMap.put(Weathers.OVERWORLD_WINTER_SNOW, "in an endless snowstorm");
         // overworldRainBlood
     }
 
@@ -158,10 +159,10 @@ public class RichPresenceHandlerThread extends Thread
         }
         else if (minecraft.theWorld != null && minecraft.thePlayer != null)
         {
-            if (minecraft.thePlayer instanceof EntityClientPlayerMP)
+            if (minecraft.thePlayer instanceof MultiplayerLocalPlayer)
             {
                 activity.setDetails("Multiplayer");
-                int playerCount = ((EntityClientPlayerMP) minecraft.thePlayer).sendQueue.players.size();
+                int playerCount = ((MultiplayerLocalPlayer) minecraft.thePlayer).sendQueue.players.size();
                 activity.party().size().setCurrentSize(playerCount);
                 activity.party().size().setMaxSize(100);
             }
diff --git a/src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java b/src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java
index 272696398..3c51810b2 100644
--- a/src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java
+++ b/src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java
@@ -1,77 +1,171 @@
 package net.minecraft.client.entity;
 
+import java.io.IOException;
+import java.io.InputStream;
+import java.util.ArrayList;
+import java.util.Comparator;
 import java.util.HashMap;
 import java.util.List;
 import java.util.Map;
 
-import com.b100.json.element.JsonEntry;
-import com.b100.json.element.JsonObject;
-
+import com.b100.utils.StringUtils;
+import com.google.gson.JsonArray;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonObject;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonParser;
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.texturepack.TexturePack;
-import net.minecraft.client.render.texturepack.TexturePackException;
-import net.minecraft.client.util.helper.TexturePackJsonHelper;
-import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.SkinVariantList;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class ClientSkinVariantList extends SkinVariantList {
+	public static final int MAX_VARIANT_ID = 0xFF;
 
 	private final Minecraft mc;
 
-	private final Map<String, Integer> entitySkinCounts = new HashMap<>();
+	private final Map<String, @Nullable EntityVariants> variantProcessorMap = new HashMap<>();
 
 	public ClientSkinVariantList(Minecraft minecraft) {
 		this.mc = minecraft;
 	}
 
-	@Override
-	public int getNumSkinsForEntity(Class<? extends Entity> entityClass) {
-		Integer count = entitySkinCounts.get(entityClass.getName());
-		
-		return count != null ? count : 1;
-	}
 
 	public void refresh(List<Throwable> errors) {
-		entitySkinCounts.clear();
-		
-		// Load default skin variants first
-		load(mc.texturePackList.getDefaultTexturePack(), errors);
-		
-		// Load custom skin variants
-		if(mc.texturePackList.getHighestPriorityPack() != mc.texturePackList.getDefaultTexturePack() && mc.texturePackList.getHighestPriorityPack().hasFile("/entity/variants.json")) {
-			load(mc.texturePackList.getHighestPriorityPack(), errors);
-		}
+		variantProcessorMap.clear();
 	}
-	
-	public void load(TexturePack texturePack, List<Throwable> errors) {
+
+
+	@Override
+	public @NotNull String getSkinReference(@Nullable String variantJsonPath, @NotNull String defaultKey, int skinIndex) {
 		try {
-			JsonObject rootObject = TexturePackJsonHelper.readJsonObject(texturePack, "/entity/variants.json");
+			if (!Minecraft.getMinecraft(this).gameSettings.mobVariants.value) return defaultKey;
+			if (variantJsonPath == null) return defaultKey;
+			if (!variantProcessorMap.containsKey(variantJsonPath)) {
+				loadJson(variantJsonPath);
+			}
+			EntityVariants var = variantProcessorMap.get(variantJsonPath);
+			if (var != null) {
+				return var.getKeyFromIndex(skinIndex);
+			}
+		} catch (Exception e) {
+			e.printStackTrace();
+		}
+		return defaultKey;
+	}
+	public void loadJson(String variantJsonPath) {
+		load: try (InputStream stream = mc.texturePackList.getResourceAsStream(variantJsonPath)){
+			if (stream == null) return;
+			String jsonString;
 			try {
-				if(rootObject.has("replace") && rootObject.getBoolean("replace")) {
-					entitySkinCounts.clear();
+				jsonString = StringUtils.readInputString(stream);
+			} catch (Exception e) {
+				e.printStackTrace();
+				break load;
+			}
+            try {
+                JsonObject variantObject = JsonParser.parseString(jsonString).getAsJsonObject();
+				if (variantObject.has("skins")) {
+					JsonElement skins = variantObject.get("skins");
+					if (skins.isJsonPrimitive()) {
+						variantProcessorMap.put(variantJsonPath, new EntityVariants(skins.getAsInt()));
+						return;
+					} else if (skins.isJsonArray()) {
+						List<EntityVariants.VariantEntry> variants = new ArrayList<>();
+						JsonArray arr = skins.getAsJsonArray();
+						for (JsonElement e: arr) {
+							JsonObject entryObj = e.getAsJsonObject();
+							String textureReference = entryObj.get("texture").getAsString();
+							double weight = 1;
+							if (entryObj.has("weight")) {
+								weight = entryObj.get("weight").getAsDouble();
+							}
+							variants.add(new EntityVariants.VariantEntry(textureReference, weight));
+						}
+						variantProcessorMap.put(variantJsonPath, new EntityVariants(variants));
+						return;
+					} else {
+						System.out.println("Error: value 'skins' must either be a integer or an array!");
+						break load;
+					}
+				}
+            } catch (JsonParseException e) { // TODO, replace with proper non-fatal error logging
+                e.printStackTrace();
+            }
+        } catch (IOException e) {
+            e.printStackTrace();
+			break load;
+        }
+		variantProcessorMap.put(variantJsonPath, null);
+    }
+
+	protected static class EntityVariants {
+
+		private final VariantEntry[] variantEntries;
+		private final int skins;
+
+		public EntityVariants(int skins) {
+			this.skins = skins;
+			this.variantEntries = null;
+		}
+
+		public EntityVariants(List<VariantEntry> entries) {
+			variantEntries = new VariantEntry[MAX_VARIANT_ID + 1];
+			this.skins = -1;
+			double accWeight = 0;
+			entries.sort(Comparator.comparingDouble(o -> -o.weight));
+
+			for (VariantEntry e : entries) {
+//				System.out.println(e.weight);
+				accWeight += e.weight;
+			}
+
+
+			main:
+			{
+				int pointer = 0;
+				for (VariantEntry e : entries) {
+					int amount = MathHelper.floor((e.weight / accWeight) * MAX_VARIANT_ID);
+					if (amount < 1) amount = 1;
+
+					for (int i = 0; i < amount; i++) {
+						variantEntries[pointer] = e;
+						pointer++;
+						if (pointer > variantEntries.length - 1) break main;
+					}
 				}
 
-				JsonObject variants = TexturePackJsonHelper.getObject(rootObject, "variants");
-				
-				for(JsonEntry entry : variants) {
-		            String key = entry.name;
-		            JsonObject value = entry.value.getAsObject();
-		            int numSkins = Math.max(1, value.getInt("numSkins"));
-		            entitySkinCounts.put(key, numSkins);
+				VariantEntry last = entries.get(0);
+				while (pointer < variantEntries.length) {
+					variantEntries[pointer] = last;
+					pointer++;
 				}
-			}catch (Exception e) {
-				throw new TexturePackException("Error in variants.json", e);
 			}
-		}catch (Exception e) {
-			errors.add(e);
-			entitySkinCounts.clear();
+
+
+			Map<String, Integer> counts = new HashMap<>();
+			for (VariantEntry e : variantEntries) {
+				counts.putIfAbsent(e.textureKey, 0);
+				counts.put(e.textureKey, counts.get(e.textureKey) + 1);
+			}
+//			System.out.println(counts);
 		}
-	}
-	
-	public void print() {
-		System.out.println("Skin Variants: ");
-		for(String key : entitySkinCounts.keySet()) {
-			System.out.println("    " + key + " : " + entitySkinCounts.get(key));
+
+		public String getKeyFromIndex(int index) {
+			if (variantEntries != null) {
+				return variantEntries[index].textureKey;
+			}
+			return String.valueOf(index % skins);
+		}
+
+		protected static class VariantEntry {
+			public final String textureKey;
+			public final double weight;
+			public VariantEntry(String key, double weight) {
+				this.textureKey = key;
+				this.weight = weight;
+			}
 		}
 	}
 }
diff --git a/src/main/java/net/minecraft/client/entity/particle/BreakingItemParticle.java b/src/main/java/net/minecraft/client/entity/particle/BreakingItemParticle.java
new file mode 100644
index 000000000..138809446
--- /dev/null
+++ b/src/main/java/net/minecraft/client/entity/particle/BreakingItemParticle.java
@@ -0,0 +1,52 @@
+package net.minecraft.client.entity.particle;
+
+import net.minecraft.client.render.LightmapHelper;
+
+// Referenced classes of package net.minecraft.src:
+//            EntityFX, Item, Block, Tessellator,
+//            World
+
+import net.minecraft.client.render.item.model.ItemModelDispatcher;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.world.World;
+
+public class BreakingItemParticle extends Particle {
+    public BreakingItemParticle(World world, double x, double y, double z, Item item)
+    {
+        super(world, x, y, z, 0.0D, 0.0D, 0.0D);
+        this.tex = ItemModelDispatcher.getInstance().getDispatch(item).getIcon(null, item.getDefaultStack());
+        this.rCol = this.gCol = this.bCol = 1.0F;
+        this.gravity = Blocks.BLOCK_SNOW.blockParticleGravity;
+        this.size /= 2.0F;
+    }
+
+    @Override
+	public int getParticleTexture() {
+        return 2;
+    }
+
+    @Override
+    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+        float u0 = (float) this.tex.getSubIconU(this.uo / 4F);
+        float u2 = (float) this.tex.getSubIconU(0.25f + this.uo / 4F);
+        float v0 = (float) this.tex.getSubIconV(this.uo / 4F);
+        float v2 = (float) this.tex.getSubIconV(0.25f + this.uo / 4F);
+        float r = 0.1F * this.size;
+        float x = (float)(xo + (this.x - this.xo) * partialTick - BreakingItemParticle.xOff);
+        float y = (float)(yo + (this.y - this.yo) * partialTick - BreakingItemParticle.yOff);
+        float z = (float)(zo + (this.z - this.zo) * partialTick - BreakingItemParticle.zOff);
+        float br = 1.0f;
+        if (LightmapHelper.isLightmapEnabled()) {
+        	t.setLightmapCoord(getLightmapCoord(partialTick));
+        } else {
+        	br = getBrightness(partialTick);
+        }
+        t.setColorOpaque_F(br * this.rCol, br * this.gCol, br * this.bCol);
+        t.addVertexWithUV(x - xa * r - xa2 * r, y - ya * r, z - za * r - za2 * r, u0, v2);
+        t.addVertexWithUV(x - xa * r + xa2 * r, y + ya * r, z - za * r + za2 * r, u0, v0);
+        t.addVertexWithUV(x + xa * r + xa2 * r, y + ya * r, z + za * r + za2 * r, u2, v0);
+        t.addVertexWithUV(x + xa * r - xa2 * r, y - ya * r, z + za * r - za2 * r, u2, v2);
+    }
+}
diff --git a/src/main/java/net/minecraft/client/entity/particle/BubbleParticle.java b/src/main/java/net/minecraft/client/entity/particle/BubbleParticle.java
new file mode 100644
index 000000000..450f0c4a8
--- /dev/null
+++ b/src/main/java/net/minecraft/client/entity/particle/BubbleParticle.java
@@ -0,0 +1,43 @@
+package net.minecraft.client.entity.particle;
+
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+
+public class BubbleParticle extends Particle {
+    private final boolean needsWater;
+
+    public BubbleParticle(World world, double x, double y, double z, double xa, double ya, double za, boolean needsWater) {
+        super(world, x, y, z, xa, ya, za);
+        this.needsWater = needsWater;
+        this.rCol = 1.0F;
+        this.gCol = 1.0F;
+        this.bCol = 1.0F;
+        this.tex = TextureRegistry.getTexture("minecraft:particle/bubble");
+        this.setSize(0.02F, 0.02F);
+        this.size = this.size * (this.random.nextFloat() * 0.6F + 0.2F);
+        this.xd = xa * 0.2D + (float)(Math.random() * 2D - 1.0D) * 0.02F;
+        this.yd = ya * 0.2D + (float)(Math.random() * 2D - 1.0D) * 0.02F;
+        this.zd = za * 0.2D + (float)(Math.random() * 2D - 1.0D) * 0.02F;
+        this.lifetime = (int)(8D / (Math.random() * 0.8D + 0.2D));
+    }
+
+    @Override
+	public void tick() {
+        this.xo = this.x;
+        this.yo = this.y;
+        this.zo = this.z;
+        this.yd += 0.002D;
+        this.move(this.xd, this.yd, this.zd);
+        this.xd *= 0.85D;
+        this.yd *= 0.85D;
+        this.zd *= 0.85D;
+        if (this.needsWater && this.world.getBlockMaterial(MathHelper.floor(this.x), MathHelper.floor(this.y), MathHelper.floor(this.z)) != Material.water) {
+            remove();
+        }
+        if(this.lifetime-- <= 0) {
+            remove();
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/client/entity/particle/ExplodeParticle.java b/src/main/java/net/minecraft/client/entity/particle/ExplodeParticle.java
new file mode 100644
index 000000000..3cad7ad5d
--- /dev/null
+++ b/src/main/java/net/minecraft/client/entity/particle/ExplodeParticle.java
@@ -0,0 +1,41 @@
+package net.minecraft.client.entity.particle;
+
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.world.World;
+
+public class ExplodeParticle extends Particle {
+    public ExplodeParticle(World world, double x, double y, double z, double xa, double ya, double za) {
+        super(world, x, y, z, xa, ya, za);
+        this.xd = xa + (float)(Math.random() * 2D - 1.0D) * 0.05F;
+        this.yd = ya + (float)(Math.random() * 2D - 1.0D) * 0.05F;
+        this.zd = za + (float)(Math.random() * 2D - 1.0D) * 0.05F;
+        this.rCol = this.gCol = this.bCol = this.random.nextFloat() * 0.3F + 0.7F;
+        this.size = this.random.nextFloat() * this.random.nextFloat() * 6F + 1.0F;
+        this.lifetime = (int)(16D / (this.random.nextFloat() * 0.8D + 0.2D)) + 2;
+    }
+
+    @Override
+	public void tick() {
+        this.xo = this.x;
+        this.yo = this.y;
+        this.zo = this.z;
+        if(this.age++ >= this.lifetime) {
+            this.remove();
+        }
+        int val = (7 - ((this.age * 8) / this.lifetime));
+        if (val >= 0) {
+            this.tex = TextureRegistry.getTexture("minecraft:particle/puff_" + val);
+        } else {
+            this.tex = null;
+        }
+        this.yd += 0.004D;
+        move(this.xd, this.yd, this.zd);
+        this.xd *= 0.9D;
+        this.yd *= 0.9D;
+        this.zd *= 0.9D;
+        if (this.onGround) {
+            this.xd *= 0.7D;
+            this.zd *= 0.7D;
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/client/entity/particle/FireflyParticle.java b/src/main/java/net/minecraft/client/entity/particle/FireflyParticle.java
new file mode 100644
index 000000000..5336dc744
--- /dev/null
+++ b/src/main/java/net/minecraft/client/entity/particle/FireflyParticle.java
@@ -0,0 +1,192 @@
+package net.minecraft.client.entity.particle;
+
+import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.entity.animal.FireflyClusterMob;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+
+public class FireflyParticle extends Particle {
+    float oSize;
+    float sinTimer = 0;
+    boolean isReversed = false;
+    float midR = 0.0f;
+    float midG = 0.0f;
+    float midB = 0.0f;
+    final float minR = 96 / 255f;
+    final float minG = 54 / 255f;
+    final float minB = 0 / 255f;
+    float maxR = 240 / 255f;
+    float maxG = 255 / 255f;
+    float maxB = 173 / 255f;
+    float oR;
+    float oG;
+    float oB;
+
+    public FireflyParticle(World world, double x, double y, double z, double xa, double ya, double za, int type) {
+        this(world, x, y, z, xa, ya, za, 1.0F, type);
+    }
+
+    public FireflyParticle(World world, double x, double y, double z, double xa, double ya, double za, float scale, int type) {
+        super(world, x, y, z, 0.0D, 0.0D, 0.0D);
+        this.xd = 0.01D;
+        this.yd = 0.01D;
+        this.zd = 0.01D;
+        this.xd += xa;
+        this.yd += ya;
+        this.zd += za;
+        this.setColor(type);
+        this.size = 2.0F;
+        this.oSize = size;
+        this.lifetime = (int) (24D + random.nextInt(6));
+        this.lifetime *= (int) scale;
+        this.noPhysics = false;
+        this.tex = TextureRegistry.getTexture("minecraft:particle/firefly");
+        if (this.random.nextInt(2) == 0) {
+            this.isReversed = true;
+        }
+        this.oR = this.random.nextFloat() * 0.06f - 0.03f;
+        this.oG = this.random.nextFloat() * 0.06f - 0.03f;
+        this.oB = this.random.nextFloat() * 0.06f - 0.03f;
+    }
+
+    private void setColor(int type){
+        float[] color = FireflyClusterMob.FireflyColor.fireFlyColors.get(type).getMidColor();
+        this.midR = color[0];
+        this.midG = color[1];
+        this.midB = color[2];
+
+        this.rCol = this.midR;
+        this.gCol = this.midG;
+        this.bCol = this.midB;
+        this.maxR = MathHelper.clamp(this.midR + 0.25f, 0.0f, 1.0f);
+        this.maxG = MathHelper.clamp(this.midG + 0.25f, 0.0f, 1.0f);
+        this.maxB = MathHelper.clamp(this.midB + 0.25f, 0.0f, 1.0f);
+    }
+
+    public void setAge(int age) {
+        this.age = age;
+    }
+
+    @Override
+    public float getBrightness(float partialTick)
+    {
+        float internalBrightness = this.getInternalBrightness(partialTick);
+        float worldBrightness = super.getBrightness(partialTick);
+        return Math.max(internalBrightness, worldBrightness);
+    }
+
+    public float getInternalBrightness(float partialTick)
+    {
+        float b = (float) (Math.sin(this.age * 0.25f) + 1.0f) / 2f;
+        return MathHelper.clamp(b, 0f, 1f);
+    }
+
+    @Override
+    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2)
+    {
+        float ibr = getInternalBrightness(partialTick);
+        if (ibr < 0.5f) {
+            this.rCol = MathHelper.lerp(this.minR, this.midR, ibr * 2);
+            this.gCol = MathHelper.lerp(this.minG, this.midG, ibr * 2);
+            this.bCol = MathHelper.lerp(this.minB, this.midB, ibr * 2);
+        } else {
+            this.rCol = MathHelper.lerp(this.midR, this.maxR, (ibr - 0.5f) * 2);
+            this.gCol = MathHelper.lerp(this.midG, this.maxG, (ibr - 0.5f) * 2);
+            this.bCol = MathHelper.lerp(this.midB, this.maxB, (ibr - 0.5f) * 2);
+        }
+
+        this.rCol += this.oR;
+        this.gCol += this.oG;
+        this.bCol += this.oB;
+
+        super.render(t, partialTick, xa, ya, za, xa2, za2);
+    }
+
+    public void renderParticleInGui(Tessellator t, float partialTick) {
+        float ibr = getInternalBrightness(partialTick);
+        if (ibr < 0.5f) {
+            this.rCol = MathHelper.lerp(this.minR, this.midR, ibr * 2);
+            this.gCol = MathHelper.lerp(this.minG, this.midG, ibr * 2);
+            this.bCol = MathHelper.lerp(this.minB, this.midB, ibr * 2);
+        } else {
+            this.rCol = MathHelper.lerp(this.midR, this.maxR, (ibr - 0.5f) * 2);
+            this.gCol = MathHelper.lerp(this.midG, this.maxG, (ibr - 0.5f) * 2);
+            this.bCol = MathHelper.lerp(this.midB, this.maxB, (ibr - 0.5f) * 2);
+        }
+
+        this.rCol += this.oR;
+        this.gCol += this.oG;
+        this.bCol += this.oB;
+
+        float u0 = (float) tex.getIconUMin();
+        float u2 = (float) tex.getSubIconU(1/16f);
+        float v0 = (float) tex.getIconVMin();
+        float v2 = (float) tex.getSubIconV(1/16f);
+        float r = 0.1F * size;
+        float x = (float)(xo + (this.x - xo) * partialTick);
+        float y = (float)(yo + (this.y - yo) * partialTick);
+        float br = 1.0f;
+        if (LightmapHelper.isLightmapEnabled()) {
+        	t.setLightmapCoord(getLightmapCoord(partialTick));
+        } else {
+        	br = getBrightness(partialTick);
+        }
+        t.setColorOpaque_F(rCol * br, gCol * br, bCol * br);
+        t.addVertexWithUV(x + r, y - r, 0, u2, v2);
+        t.addVertexWithUV(x + r, y + r, 0, u2, v0);
+        t.addVertexWithUV(x - r, y + r, 0, u0, v0);
+        t.addVertexWithUV(x - r, y - r, 0, u0, v2);
+    }
+    
+    @Override
+    public int getLightmapCoord(float partialTick) {
+    	return LightmapHelper.setBlocklightValue(super.getLightmapCoord(partialTick), 15);
+    }
+
+    public void tickGui() {
+        this.sinTimer++;
+        if (this.sinTimer > 100) {
+            this.sinTimer = 0;
+        }
+
+        if (this.age++ >= this.lifetime && getInternalBrightness(1.0F) < 0.01f) {
+            this.remove();
+        }
+
+        this.xo = this.x;
+        this.yo = this.y;
+        this.xd = (MathHelper.sin((this.sinTimer) * 0.15f)) / 60f;
+        this.yd = (MathHelper.cos((this.sinTimer) * 0.15f)) / 60f;
+        if (this.isReversed){
+            this.xd = -this.xd;
+            this.yd = -this.yd;
+        }
+        this.move(this.xd, this.yd, 0);
+    }
+
+    @Override
+    public void tick() {
+        this.sinTimer++;
+        if (this.sinTimer > 100) {
+            sinTimer = 0;
+        }
+
+        if (this.age++ >= this.lifetime && getInternalBrightness(1.0f) < 0.01f) {
+            this.remove();
+        }
+
+        this.xo = this.x;
+        this.yo = this.y;
+        this.zo = this.z;
+        this.xd = (MathHelper.sin(this.sinTimer * 0.15f)) / 60f;
+        this.zd = (MathHelper.cos(this.sinTimer * 0.15f)) / 60f;
+        if (this.isReversed){
+            this.xd = -this.xd;
+            this.yd = -this.yd;
+            this.zd = -this.zd;
+        }
+        this.move(this.xd, this.yd, this.zd);
+    }
+}
\ No newline at end of file
